Index: trunk/kernel/kern/do_syscall.c
===================================================================
--- trunk/kernel/kern/do_syscall.c	(revision 16)
+++ trunk/kernel/kern/do_syscall.c	(revision 23)
@@ -2,5 +2,5 @@
  * do_syscall.c - architecture independant entry-point for system calls.
  * 
- * AUthor    Alain Greiner (2016)
+ * Author    Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -31,5 +31,14 @@
 
 /////////////////////////////////////////////////////////////////////////////////////////////
-// This array of pointers define the kernel functions for syscalls.
+/////////////////////////////////////////////////////////////////////////////////////////////
+static inline int sys_undefined()
+{
+    printk("\n[PANIC] in %s : undefined system call\n", __FUNCTION__ );
+    hal_core_sleep();
+    return 0;
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////////
+// This array of pointers define the kernel functions implementing the syscalls.
 // It must be kept consistent with the enum in syscalls.h
 /////////////////////////////////////////////////////////////////////////////////////////////
@@ -39,55 +48,44 @@
 static const sys_func_t syscall_tbl[SYSCALLS_NR] = 
 {
-	sys_thread_exit,        // 0
-	sys_mmap,               // 1
-	sys_thread_create,      // 2
-	sys_thread_join,        // 3
-	sys_thread_detach,      // 4
-	sys_thread_yield,       // 5
-	sys_sem,                // 6
-	sys_cond_var,           // 7
-	sys_barrier,            // 8
-	sys_rwlock,             // 9
-	sys_thread_sleep,       // 10
-	sys_thread_wakeup,      // 11
-	sys_open,               // 12
-	sys_creat,              // 13
-	sys_read,               // 14
-	sys_write,              // 15
-	sys_lseek,              // 16
-	sys_close,              // 17
-	sys_unlink,             // 18
-	sys_pipe,               // 19
-	sys_chdir,              // 20
-	sys_mkdir,              // 21
-	sys_mkfifo,             // 22
-	sys_opendir,            // 23
-	sys_readdir,            // 24
-	sys_closedir,           // 25
-	sys_getcwd,             // 26
-	sys_clock,              // 27
-	sys_alarm,              // 28
-	sys_dma_memcpy,         // 29
-	sys_utls,               // 30
-	sys_notAvailable,		// 31        Reserved for sigreturn TODO  ???
-	sys_signal,             // 32 
-	sys_sigreturn_setup,    // 33
-	sys_kill,               // 34
-	sys_getpid,             // 35
-	sys_fork,               // 36
-	sys_exec,               // 37
-	sys_thread_getattr,     // 38
-	sys_ps,                 // 39
-	sys_madvise,            // 40
-	sys_mcntl,              // 41
-	sys_stat,               // 42
-	sys_thread_migrate,     // 43
-	sys_sbrk,               // 44
-	sys_rmdir,              // 45
-	sys_ftime,              // 46
-	sys_chmod,              // 47
-	sys_fsync,              // 48
-	sys_gettimeofday,       // 49
-	sys_times               // 50
+    sys_thread_exit,        // 0
+    sys_mmap,               // 1
+    sys_thread_create,      // 2
+    sys_thread_join,        // 3
+    sys_thread_detach,      // 4
+    sys_thread_yield,       // 5
+    sys_sem,                // 6
+    sys_condvar,            // 7
+    sys_barrier,            // 8
+    sys_mutex,              // 9
+    sys_thread_sleep,       // 10
+    sys_thread_wakeup,      // 11
+    sys_open,               // 12
+    sys_creat,              // 13
+    sys_read,               // 14
+    sys_write,              // 15
+    sys_lseek,              // 16
+    sys_close,              // 17
+    sys_unlink,             // 18
+    sys_pipe,               // 19
+    sys_chdir,              // 20
+    sys_mkdir,              // 21
+    sys_mkfifo,             // 22
+    sys_opendir,            // 23
+    sys_readdir,            // 24
+    sys_closedir,           // 25
+    sys_getcwd,             // 26
+    sys_clock,              // 27
+    sys_alarm,              // 28
+    sys_rmdir,              // 29
+    sys_utls,               // 30
+    sys_chmod,              // 31
+    sys_signal,             // 32 
+    sys_gettimeofday,       // 33
+    sys_kill,               // 34
+    sys_getpid,             // 35
+    sys_fork,               // 36
+    sys_exec,               // 37
+    sys_stat,               // 38
+    sys_trace,              // 39
 };
 
